Index: typo3/sysext/rtehtmlarea/htmlarea/skins/default/htmlarea.css
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/skins/default/htmlarea.css	(révision 8012)
+++ typo3/sysext/rtehtmlarea/htmlarea/skins/default/htmlarea.css	(copie de travail)
@@ -19,12 +19,11 @@
  	padding: 0;
 }
 .editorWrap textarea {
-	border: 1px solid #A2AAB8;
-	border-style:solid;
-	border-color:#A2AAB8;
-	border-width:0px 1px 1px 1px;
-	padding:0px 1px;
-	margin:0;
+	border-style: solid;
+	border-color: #C7C7C7;
+	border-width: 0px 1px 1px 1px;
+	padding: 0px 1px;
+	margin: 0;
 }
 .editorWrap .resizable {
 	background-image: url("images/status/resizable.gif");
@@ -37,9 +36,9 @@
 }
 /* Selectors for the editor toolbar */
 .htmlarea .toolbar {
-	background-color: #E4E0DB;
+	background-color: #f3f3f3;
 	cursor: default;
-	border: 1px solid #A2AAB8;
+	border: 1px solid #c7c7c7;
 	border-bottom: 0;
 	margin: 0;
 	padding: 2px;
@@ -76,6 +75,10 @@
 	padding: 0;
 	float: left;
 }
+/* fixing button border-color in IE6 */
+body.ext-ie6 .htmlarea .toolbar .button {
+	border-color: #f3f3f3;
+}
 .htmlarea .toolbar .x-btn-mc {
 	background-color: transparent;
 	background-image: none;
@@ -101,6 +104,8 @@
 	padding: 0;
 	margin: 1px 0 1px 2px;
 }
+/* fixing button background-color and border-color in IE6 */
+body.ext-ie6 .htmlarea .toolbar .buttonHover,
 .htmlarea .toolbar .buttonHover {
 	border-style: solid;
 	border-width: 1px;
@@ -108,6 +113,10 @@
 	background-color: #E0E0E9;
 	opacity: 1.00;
 }
+/* fixing button background-color and border-color in IE6 */
+body.ext-ie6 .htmlarea .toolbar .buttonActive,
+body.ext-ie6 .htmlarea .toolbar .buttonPressed,
+body.ext-ie6 .htmlarea-context-menu .buttonActive,
 .htmlarea .toolbar .buttonActive,
 .htmlarea .toolbar .buttonPressed,
 .htmlarea-context-menu .buttonActive {
@@ -165,20 +174,26 @@
 	background-color:#e4e0db;
 }
 .htmlarea .editorIframe {
-	clear:both;
-	width:100%;
-	border:1px solid #A2AAB8;border-bottom:1px solid #e4e0db;
-	margin:0;padding:0;
+	clear: both;
+	width: 100%;
+	border: 1px solid #c7c7c7;
+	border-bottom: none;
+	margin: 0;
+	padding: 0;
 }
 .htmlarea .noStatusBar {
 	border-bottom:1px solid #000;
 }
 .htmlarea .statusBar {
-	color:ButtonText;
-	background-color:#e4e0db;
-	font-size:10px;
-	font-family: Verdana, Helvetica, Geneva, Arial, sans-serif;
-	border:1px solid;border-color:#C5C5D5 #A2AAB8 #A2AAB8 #A2AAB8;
+        background-color: #5b5b5b;
+        background-image: url('images/backgrounds/row-header.png');
+        background-image: linear-gradient(center top , #7f7f7f 10%, #5b5b5b 100%);
+        background-image: -moz-linear-gradient(center top , #7f7f7f 10%, #5b5b5b 100%);
+        background-image: -webkit-gradient(linear, 0% 0%, 0% 100%, color-stop(0.1, #7f7f7f), color-stop(1, #5b5b5b));
+        background-repeat: repeat-x;
+	color: #FFFFFF;
+	font-size: 10px;
+	border: 1px solid #c7c7c7;
 	margin: 0;
 	padding: 0 3px;
 	line-height: 20px;
@@ -352,6 +367,13 @@
 	width: 18px;
 	height: 18px;
 }
+/* Remove the icons in IE6 as they are not iepngfixed */
+body.ext-ie6 .htmlarea-context-menu a.x-menu-item {
+	padding-left: 3px;
+}
+body.ext-ie6 .htmlarea-context-menu .x-menu-item-icon {
+	background-image: none;
+}
 /* Window status bar selectors */
 .htmlarea-window .status-ready {
 	padding-left: 21px !important;
Index: typo3/sysext/rtehtmlarea/htmlarea/skins/default/images/row-header.png
===================================================================
Impossible d'afficher : fichier considéré comme binaire.
svn:mime-type = application/octet-stream

Modification de propriétés sur typo3\sysext\rtehtmlarea\htmlarea\skins\default\images\row-header.png
___________________________________________________________________
Ajouté : svn:mime-type
   + application/octet-stream

Index: typo3/sysext/rtehtmlarea/pi2/class.tx_rtehtmlarea_pi2.php
===================================================================
--- typo3/sysext/rtehtmlarea/pi2/class.tx_rtehtmlarea_pi2.php	(révision 8012)
+++ typo3/sysext/rtehtmlarea/pi2/class.tx_rtehtmlarea_pi2.php	(copie de travail)
@@ -207,6 +207,7 @@
 			// Preloading the pageStyle and including RTE skin stylesheets
 		$this->addPageStyle();
 		$this->addSkin();
+		$this->addPngFix();
 		$pageRenderer->addCssFile($this->siteURL . 't3lib/js/extjs/ux/resize.css');
 			// Loading JavaScript files and code
 		$pageRenderer->loadExtJs();
@@ -258,7 +259,6 @@
 			';
 		return $item;
 	}
-
 	/**
 	 * Add style sheet file to document header
 	 *
@@ -273,6 +273,18 @@
 		$pageRenderer->addCssFile($href, $relation, 'screen', $title);
 	}
 	/**
+	 * Add iepngfix js and inline css for IE6, if available (t3skin must be loaded)
+	 *
+	 * @return	void
+	 */
+	protected function addPngFix() {
+		if ($this->client['browser'] == 'msie' && $this->client['version'] < 7 && t3lib_extMgm::isLoaded('t3skin')) {
+			$pageRenderer = $GLOBALS['TSFE']->getPageRenderer();
+			$pageRenderer->addJsFile($this->siteURL . t3lib_extMgm::siteRelPath('t3skin') . 'pngfix/iepngfix.js');
+			$pageRenderer->addCssInlineBlock('htmlarea-iepngfix', ".htmlarea .toolbar .x-btn-text, .htmlarea-window .x-panel-icon { behavior: url('" . $this->siteURL . t3lib_extMgm::siteRelPath('t3skin') . 'pngfix/iepngfix.php' . "\');");
+		}
+	}
+	/**
 	 * Return true if we are in the FE, but not in the FE editing feature of BE.
 	 *
 	 * @return boolean
Index: typo3/sysext/t3skin/pngfix/class.tx_templatehook.php
===================================================================
--- typo3/sysext/t3skin/pngfix/class.tx_templatehook.php	(révision 8012)
+++ typo3/sysext/t3skin/pngfix/class.tx_templatehook.php	(copie de travail)
@@ -10,7 +10,7 @@
 		&& strpos($userAgent, 'MSIE 7') === false) {
 				//make sure we match IE6 but not Opera or IE7
 				$parent->loadJavascriptLib('sysext/t3skin/pngfix/iepngfix.js');
-				$params['pageRenderer']->addCssInlineBlock('iepngfix', ".t3-icon { behavior: url('" . $parent->backPath . 'sysext/t3skin/pngfix/iepngfix.php' . "\');");
+				$params['pageRenderer']->addCssInlineBlock('iepngfix', ".t3-icon, .htmlarea .toolbar .x-btn-text, .htmlarea-window .x-panel-icon { behavior: url('" . $parent->backPath . 'sysext/t3skin/pngfix/iepngfix.php' . "\');");
 		}
 
 	}
Index: typo3/sysext/t3skin/rtehtmlarea/htmlarea.css
===================================================================
--- typo3/sysext/t3skin/rtehtmlarea/htmlarea.css	(révision 8012)
+++ typo3/sysext/t3skin/rtehtmlarea/htmlarea.css	(copie de travail)
@@ -75,6 +75,10 @@
 	padding: 0;
 	float: left;
 }
+/* fixing button border-color in IE6 */
+body.ext-ie6 .htmlarea .toolbar .button {
+	border-color: #f3f3f3;
+}
 .htmlarea .toolbar .x-btn-mc {
 	background-color: transparent;
 	background-image: none;
@@ -100,6 +104,8 @@
 	padding: 0;
 	margin: 1px 0 1px 2px;
 }
+/* fixing button background-color and border-color in IE6 */
+body.ext-ie6 .htmlarea .toolbar .buttonHover,
 .htmlarea .toolbar .buttonHover {
 	border-style: solid;
 	border-width: 1px;
@@ -107,6 +113,10 @@
 	background-color: #E0E0E9;
 	opacity: 1.00;
 }
+/* fixing button background-color and border-color in IE6 */
+body.ext-ie6 .htmlarea .toolbar .buttonActive,
+body.ext-ie6 .htmlarea .toolbar .buttonPressed,
+body.ext-ie6 .htmlarea-context-menu .buttonActive,
 .htmlarea .toolbar .buttonActive,
 .htmlarea .toolbar .buttonPressed,
 .htmlarea-context-menu .buttonActive {
@@ -362,6 +372,13 @@
 	width: 18px;
 	height: 18px;
 }
+/* Remove the icons in IE6 as they are not iepngfixed */
+body.ext-ie6 .htmlarea-context-menu a.x-menu-item {
+	padding-left: 3px;
+}
+body.ext-ie6 .htmlarea-context-menu .x-menu-item-icon {
+	background-image: none;
+}
 /* Window status bar selectors */
 .htmlarea-window .status-ready {
 	padding-left: 21px !important;